'use client'
import { useMutation } from '@tanstack/react-query'
import { BuildTypesAdd } from './types'
import { toISOIfNotZ } from '@/lib/utils';

const fetchGraphQlBuildTypesAdd = async (record: BuildTypesAdd, refetchTable: () => void): Promise<{ data: BuildTypesAdd | null; status: number }> => {
    console.log('Fetching test data from local API');
    record.expiryStarts = record?.expiryStarts ? toISOIfNotZ(record.expiryStarts || "") : undefined;
    record.expiryEnds = record?.expiryEnds ? toISOIfNotZ(record.expiryEnds || "") : undefined;
    try {
        const res = await fetch('/api/build-types/add', { method: 'POST', cache: 'no-store', credentials: "include", body: JSON.stringify(record) });
        if (!res.ok) { const errorText = await res.text(); console.error('Test data API error:', errorText); throw new Error(`API error: ${res.status} ${res.statusText}`) }
        const data = await res.json(); refetchTable();
        return { data: data.data, status: res.status }
    } catch (error) { console.error('Error fetching test data:', error); throw error }
};

export function useAddBuildTypesMutation() {
    return useMutation({
        mutationFn: ({ data, refetchTable }: { data: BuildTypesAdd, refetchTable: () => void }) => fetchGraphQlBuildTypesAdd(data, refetchTable),
        onSuccess: () => { console.log("Build Types created successfully") },
        onError: (error) => { console.error("Create build types failed:", error) },
    })
}
